{Written by Attila Szomor, his e-mail: aszomor@dravanet.hu}
{$IfDef Win32}
  {$APPTYPE CONSOLE}
{$EndIf}

Program TestCRT;
Uses
{$IFDEF MSWINDOWS}
  CRT32 in 'WIN32\CRT32.pas',
{$ENDIF}
{$IFDEF LINUX}
  ncurses in 'UNIX/ncurses.pas',
  nCRT in 'UNIX/nCRT.pas',
{$ENDIF}
  NewCRT;
  
Var
  S: {$IfDef Win32}ShortString{$Else}String{$EndIf};
  LastCol,LastRow, OldCursor: Word;

{  }
{  The "_" cursor blinking at actual position and wait for press any key }
{  }
Procedure ReadKeyWithUlCursor;
Begin
  SetCursor(UlCursor);
  ReadKey;
  SetCursor(NoCursor);
End;
{  }
{  Clear the screen and write the window informations }
{  }
Procedure WriteWindowRect;
Begin
  ClrScr;
  WriteLn('WinMax: ',Lo(WindMax),'/',Hi(WindMax),' Press any key ...');
  Repeat
  Until KeyPressed OR MouseKeyPressed;
  If MousePressedButtons=0 Then
    ReadKey
  Else 
    WriteLn('Mouse(X,Y)=(',MouseWhereX,',',MouseWhereY,')');
End;
{  }
{  Write the next operation name on screen }
{  }
Procedure ShowOperation( Name: String );
Begin
  Write(#13#10' '+Name);
  ReadKeyWithUlCursor;
End;
{  }
{  Make a random window and show it }
{  }
procedure MakeWindow;
var
  X,Y,Width,Height: Word;
begin
  Width:=Random(LastCol-2)+2;          { random window size }
  Height:=Random(LastRow-2)+2;
  X:=Random(LastCol-Width)+1;          { random position on screen }
  Y:=Random(LastRow-Height)+1;
  Window(X,Y,X+Width,Y+Height);
  TextBackground(Random(8));
  TextColor(Random(7)+9);
  ClrScr;
end;
{  }
{  The test program }
{  }
BEGIN
  MouseGotoXY(1,1);
  {  }
  OldCursor:= GetSetCursor(NoCursor);
  TextColor(White);
  TextBackground(Blue);
  WriteWindowRect;
  {  }
  ShowOperation( 'DrawBorder(1,1,80,25,ThinLine);' );
  DrawBorder(1,1,80,25,ThinLine);
  WriteWindowRect;
  {  }
  ShowOperation( 'FillerScreen('''');' );
  FillerScreen('');
  {  }
  ShowOperation( 'Window(20, 5,60,20);' );
  DrawBorder(19,4,43,18,ThinLine);
  Window(20, 5,60,20);
  TextBackground(Red);
  WriteWindowRect;
  {  }
  S:='01234567890123456789012345678901234567890123456789';
  ShowOperation( 'WriteLn(S);' );
  WriteLn(S);
  ShowOperation( 'GotoXY(1,16);WriteLn(S);' );
  GotoXY(1,16);WriteLn(S);
  {  }
  GotoXY(1,8);
  ShowOperation( 'GotoXY(WhereX,WhereY);InsLine;' );
  GotoXY(WhereX,WhereY);InsLine;
  ReadKey;
  {  }
  ShowOperation( 'GotoXY(WhereX,WhereY);DelLine;' );
  GotoXY(WhereX,WhereY);DelLine;
  ReadKey;
  {  }
  ClrScr;
  ShowOperation( 'DrawBorder(1,1,80,25,DoubleLinLine);' );
  TextBackground(Green);
  DrawBorder(1,1,80,25,DoubleLine);
  WriteWindowRect;
  ShowOperation( 'Repeat RandomWindows Until Keypressed;' );
  {  }
  Window(1,1,80,25);
  TextBackground(Green);
  ClrScr;
  LastCol:=Lo(WindMax)+1;
  LastRow:=Hi(WindMax)+1;
  Randomize;
  Repeat
    MakeWindow;
  Until KeyPressed;
  ReadKey;
  {  }
  {Alarm;}
  {  }
  Window(1,1,80,25);
  TextBackground(Black);
  TextColor(LightGray);
  ClrScr;
  SetCursor(OldCursor);
END.
