{Written by Attila Szomor, his e-mail: aszomor@dravanet.hu}

unit ncurses;
interface

uses
  Libc;

const
  LIB_NCURSES = 'libncurses.so';

  NCURSES_VERSION_MAJOR = 5;
  {$EXTERNALSYM NCURSES_VERSION_MAJOR}
  NCURSES_VERSION_MINOR = 0;
  {$EXTERNALSYM NCURSES_VERSION_MINOR}
  NCURSES_VERSION_PATCH = 19991023;
  {$EXTERNALSYM NCURSES_VERSION_PATCH}
  NCURSES_VERSION = '5.0';
  {$EXTERNALSYM NCURSES_VERSION}

type
  pchtype = PChar;
  chtype = LongWord;
  {$EXTERNALSYM chtype}
  bool = byte;
  {$EXTERNALSYM bool}

const
  A_NORMAL = chtype(0);
  {$EXTERNALSYM A_NORMAL}
  A_ATTRIBUTES = chtype(chtype(not 0) shl 8);
  {$EXTERNALSYM A_ATTRIBUTES}
  A_CHARTEXT = chtype(longInt(1 shl (0 + 8)) - longInt(1));
  {$EXTERNALSYM A_CHARTEXT}
  A_COLOR= chtype((longInt(1 shl 8) - longInt(1)) shl 8);
  {$EXTERNALSYM A_COLOR}
  A_STANDOUT = chtype(1 shl (8 + 8));
  {$EXTERNALSYM A_STANDOUT}
  A_UNDERLINE = chtype(1 shl (9 + 8));
  {$EXTERNALSYM A_UNDERLINE}
  A_REVERSE = chtype(1 shl (10 + 8));
  {$EXTERNALSYM A_REVERSE}
  A_BLINK = chtype(1 shl (11 + 8));
  {$EXTERNALSYM A_BLINK}
  A_DIM = chtype(1 shl (12 + 8));
  {$EXTERNALSYM A_DIM}
  A_BOLD = chtype(1 shl (13 + 8));
  {$EXTERNALSYM A_BOLD}
  A_ALTCHARSET = chtype(1 shl (14 + 8));
  {$EXTERNALSYM A_ALTCHARSET}
  A_INVIS = chtype(1 shl (15 + 8));
  {$EXTERNALSYM A_INVIS}
  A_PROTECT = chtype(1 shl (16 + 8));
  {$EXTERNALSYM A_PROTECT}
  A_HORIZONTAL = chtype(1 shl (17 + 8));
  {$EXTERNALSYM A_HORIZONTAL}
  A_LEFT = chtype(1 shl (18 + 8));
  {$EXTERNALSYM A_LEFT}
  A_LOW = chtype(1 shl (19 + 8));
  {$EXTERNALSYM A_LOW}
  A_RIGHT = chtype(1 shl (20 + 8));
  {$EXTERNALSYM A_RIGHT}
  A_TOP = chtype(1 shl (21 + 8));
  {$EXTERNALSYM A_TOP}
  A_VERTICAL = chtype(1 shl (22 + 8));
  {$EXTERNALSYM A_VERTICAL}

(*
 * XSI attributes.  In the ncurses implementation, they are identical to the
 * A_ attributes.
 *)
const
  WA_NORMAL     = A_NORMAL;
  {$EXTERNALSYM WA_NORMAL}
  WA_ATTRIBUTES = A_ATTRIBUTES;
  {$EXTERNALSYM WA_ATTRIBUTES}
  WA_STANDOUT   = A_STANDOUT;
  {$EXTERNALSYM WA_STANDOUT}
  WA_UNDERLINE  = A_UNDERLINE;
  {$EXTERNALSYM WA_UNDERLINE}
  WA_REVERSE    = A_REVERSE;
  {$EXTERNALSYM WA_REVERSE}
  WA_BLINK      = A_BLINK;
  {$EXTERNALSYM WA_BLINK}
  WA_DIM        = A_DIM;
  {$EXTERNALSYM WA_DIM}
  WA_BOLD       = A_BOLD;
  {$EXTERNALSYM WA_BOLD}
  WA_ALTCHARSET = A_ALTCHARSET;
  {$EXTERNALSYM WA_ALTCHARSET}
  WA_INVIS      = A_INVIS;
  {$EXTERNALSYM WA_INVIS}
  WA_PROTECT    = A_PROTECT;
  {$EXTERNALSYM WA_PROTECT}
  WA_HORIZONTAL = A_HORIZONTAL;
  {$EXTERNALSYM WA_HORIZONTAL}
  WA_LEFT       = A_LEFT;
  {$EXTERNALSYM WA_LEFT}
  WA_LOW        = A_LOW;
  {$EXTERNALSYM WA_LOW}
  WA_RIGHT      = A_RIGHT;
  {$EXTERNALSYM WA_RIGHT}
  WA_TOP        = A_TOP;
  {$EXTERNALSYM WA_TOP}
  WA_VERTICAL   = A_VERTICAL;
  {$EXTERNALSYM WA_VERTICAL}

(* colors *)
var
  COLORS: longint;
  {$EXTERNALSYM COLORS}
  COLOR_PAIRS: longint;
  {$EXTERNALSYM COLOR_PAIRS}

const
  COLOR_BLACK = 0;
  {$EXTERNALSYM COLOR_BLACK}
  COLOR_RED = 1;
  {$EXTERNALSYM COLOR_RED}
  COLOR_GREEN = 2;
  {$EXTERNALSYM COLOR_GREEN}
  COLOR_YELLOW = 3;
  {$EXTERNALSYM COLOR_YELLOW}
  COLOR_BLUE = 4;
  {$EXTERNALSYM COLOR_BLUE}
  COLOR_MAGENTA = 5;
  {$EXTERNALSYM COLOR_MAGENTA}
  COLOR_CYAN = 6;
  {$EXTERNALSYM COLOR_CYAN}
  COLOR_WHITE = 7;
  {$EXTERNALSYM COLOR_WHITE}


(* line graphics *)
type
    tacs_map = array [char] of chtype;
    pacs_map = ^tacs_map;

var
  acs_map: tacs_map;
  {$EXTERNALSYM acs_map}

(* VT100 symbols begin here *)
  function ACS_ULCORNER: chtype;
  {$EXTERNALSYM ACS_ULCORNER}
  function ACS_LLCORNER: chtype;
  {$EXTERNALSYM ACS_LLCORNER}
  function ACS_URCORNER: chtype;
  {$EXTERNALSYM ACS_URCORNER}
  function ACS_LRCORNER: chtype;
  {$EXTERNALSYM ACS_LRCORNER}
  function ACS_LTEE: chtype;
  {$EXTERNALSYM ACS_LTEE}
  function ACS_RTEE: chtype;
  {$EXTERNALSYM ACS_RTEE}
  function ACS_BTEE: chtype;
  {$EXTERNALSYM ACS_BTEE}
  function ACS_TTEE: chtype;
  {$EXTERNALSYM ACS_TTEE}
  function ACS_HLINE: chtype;
  {$EXTERNALSYM ACS_HLINE}
  function ACS_VLINE: chtype;
  {$EXTERNALSYM ACS_VLINE}
  function ACS_PLUS: chtype;
  {$EXTERNALSYM ACS_PLUS}
  function ACS_S1: chtype;
  {$EXTERNALSYM ACS_S1}
  function ACS_S9: chtype;
  {$EXTERNALSYM ACS_S9}
  function ACS_DIAMOND: chtype;
  {$EXTERNALSYM ACS_DIAMOND}
  function ACS_CKBOARD: chtype;
  {$EXTERNALSYM ACS_CKBOARD}
  function ACS_DEGREE: chtype;
  {$EXTERNALSYM ACS_DEGREE}
  function ACS_PLMINUS: chtype;
  {$EXTERNALSYM ACS_PLMINUS}
  function ACS_BULLET: chtype;
  {$EXTERNALSYM ACS_BULLET}
(* Teletype 5410v1 symbols begin here *)
  function ACS_LARROW: chtype;
  {$EXTERNALSYM ACS_LARROW}
  function ACS_RARROW: chtype;
  {$EXTERNALSYM ACS_RARROW}
  function ACS_DARROW: chtype;
  {$EXTERNALSYM ACS_DARROW}
  function ACS_UARROW: chtype;
  {$EXTERNALSYM ACS_UARROW}
  function ACS_BOARD: chtype;
  {$EXTERNALSYM ACS_BOARD}
  function ACS_LANTERN: chtype;
  {$EXTERNALSYM ACS_LANTERN}
  function ACS_BLOCK: chtype;
  {$EXTERNALSYM ACS_BLOCK}
(*
 * These aren't documented, but a lot of System Vs have them anyway
 * (you can spot pprryyzz{{||}} in a lot of AT&T terminfo strings).
 * The ACS_names may not match AT&T's, our source didn't know them.
 *)
  function ACS_S3: chtype;
  {$EXTERNALSYM ACS_S3}
  function ACS_S7: chtype;
  {$EXTERNALSYM ACS_S7}
  function ACS_GEQUAL: chtype;
  {$EXTERNALSYM ACS_GEQUAL}
  function ACS_PI: chtype;
  {$EXTERNALSYM ACS_PI}
  function ACS_NEQUAL: chtype;
  {$EXTERNALSYM ACS_NEQUAL}
  function ACS_STERLING: chtype;
  {$EXTERNALSYM ACS_STERLING}

(*
 * Line drawing ACS names are of the form ACS_trbl, where t is the top, r
 * is the right, b is the bottom, and l is the left.  t, r, b, and l might
 * be B (blank), S (single), D (double), or T (thick).  The subset defined
 * here only uses B and S.
 *)
  function ACS_BSSB: chtype; // ACS_ULCORNER
  {$EXTERNALSYM ACS_BSSB}
  function ACS_SSBB: chtype; // ACS_LLCORNER
  {$EXTERNALSYM ACS_SSBB}
  function ACS_BBSS: chtype; // ACS_URCORNER
  {$EXTERNALSYM ACS_BBSS}
  function ACS_SBBS: chtype; // ACS_LRCORNER
  {$EXTERNALSYM ACS_SBBS}
  function ACS_SBSS: chtype; // ACS_RTEE
  {$EXTERNALSYM ACS_SBSS}
  function ACS_SSSB: chtype; // ACS_LTEE
  {$EXTERNALSYM ACS_SSSB}
  function ACS_SSBS: chtype; // ACS_BTEE
  {$EXTERNALSYM ACS_SSBS}
  function ACS_BSSS: chtype; // ACS_TTEE
  {$EXTERNALSYM ACS_BSSS}
  function ACS_BSBS: chtype; // ACS_HLINE
  {$EXTERNALSYM ACS_BSBS}
  function ACS_SBSB: chtype; // ACS_VLINE
  {$EXTERNALSYM ACS_SBSB}
  function ACS_SSSS: chtype; // ACS_PLUS
  {$EXTERNALSYM ACS_SSSS}

Const
  ERR = -(1);
  {$EXTERNALSYM ERR}
  OK = 0;
  {$EXTERNALSYM OK}

(* values for the _flags member *)
  _SUBWIN = $01;
  {$EXTERNALSYM _SUBWIN}
  _ENDLINE = $02;
  {$EXTERNALSYM _ENDLINE}
  _FULLWIN = $04;
  {$EXTERNALSYM _FULLWIN}
  _SCROLLWIN = $08;
  {$EXTERNALSYM _SCROLLWIN}
  _ISPAD = $10;
  {$EXTERNALSYM _ISPAD}
  _HASMOVED = $20;
  {$EXTERNALSYM _HASMOVED}
  _WRAPPED = $40;
  {$EXTERNALSYM _WRAPPED}
(*
 * this value is used in the firstchar and lastchar fields to mark
 * unchanged lines
 *)
  _NOCHANGE = -(1);
  {$EXTERNALSYM _NOCHANGE}
(*
 * this value is used in the oldindex field to mark lines created by insertions
 * and scrolls.
 *)
  _NEWINDEX = -(1);
  {$EXTERNALSYM _NEWINDEX}

type
  PWINDOW = ^WINDOW;
  {$EXTERNALSYM PWINDOW}
  PSCREEN = PWINDOW;
  {$EXTERNALSYM PSCREEN}

  short = smallInt;
  attr_t = chtype;
  {$EXTERNALSYM attr_t}

  pldat = ^ldat;
  ldat = record
    text      : pchtype;
    firstchar : short;
    lastchar  : short;
    oldindex  : short;
  end;
  {$EXTERNALSYM ldat}

  p_pad = ^t_pad;
  t_pad = record
    _pad_y      : short;
    _pad_x      : short;
    _pad_top    : short;
    _pad_left   : short;
    _pad_bottom : short;
    _pad_right  : short;
  end;

  p_win_st = ^_win_st;
  _win_st = record
    _cury       : short;
    _curx       : short;

    _maxy       : short;
    _maxx       : short;
    _begy       : short;
    _begx       : short;

    _flags      : short;

    _attrs      : attr_t;
    _bkgd       : chtype;

    _notimeout  : bool;
    _clear      : bool;
    _leaveok    : bool;
    _scroll     : bool;
    _idlok      : bool;
    _idcok      : bool;
    _immed      : bool;
    _sync       : bool;
    _use_keypad : bool;
    _delay      : longint;

    _line       : pldat;

    _regtop     : short;
    _regbottom  : short;

    _parx       : longint;
    _pary       : longint;

    _parent     : PWINDOW;
    _pad        : t_pad;
    _yoffset    : short;
  end;
  {$EXTERNALSYM _win_st}

  WINDOW = _win_st;
  {$EXTERNALSYM WINDOW}
  SCREEN  = WINDOW;
  {$EXTERNALSYM SCREEN}

var
  stdscr: PWINDOW;
  {$EXTERNALSYM stdscr}
  curscr: PWINDOW;
  {$EXTERNALSYM curscr}
  newscr: PWINDOW;
  {$EXTERNALSYM newscr}
  LINES: longint;
  {$EXTERNALSYM LINES}
  COLS: longint;
  {$EXTERNALSYM COLS}
  TABSIZE: longint;
  {$EXTERNALSYM TABSIZE}
  ESCDELAY: longint;
  {$EXTERNALSYM ESCDELAY}

  function keybound(_para1: longInt; _para2: longInt): PChar; cdecl; external LIB_NCURSES;
  function curses_version: PChar; cdecl; external LIB_NCURSES;
  function define_key(_para1:pchar; _para2:longint):longint; cdecl; external LIB_NCURSES;
  function keyok(_para1:longint; _para2:bool):longint; cdecl; external LIB_NCURSES;
  function resizeterm(_para1:longint; _para2:longint):longint; cdecl; external LIB_NCURSES;
  function use_default_colors:longint; cdecl; external LIB_NCURSES;
  function wresize(_para1:pWINDOW; _para2:longint; _para3:longint):longint; cdecl; external LIB_NCURSES;

var
  ttytype: array [0..0] of char;
  {$EXTERNALSYM ttytype}
type
  pFILE = pointer;
  va_list = pointer;
  tinitfn = function (win: pWINDOW; _para2: longint): longint;
  tnc1fn = function (_para1:longint): longint;
(*
 * IMPLEMENTED functions
 *)
  function baudrate:longint; cdecl; external LIB_NCURSES;
  function beep:longint; cdecl; external LIB_NCURSES;
  function can_change_color:bool; cdecl; external LIB_NCURSES;
  function cbreak:longint; cdecl; external LIB_NCURSES;
  function clearok(_para1:pWINDOW; _para2:bool):longint; cdecl; external LIB_NCURSES;
  function color_content(_para1:longint; _para2:plongint; _para3:plongint; _para4:plongint):longint; cdecl; external LIB_NCURSES;
  function copywin(
    _para1:pWINDOW; _para2:pWINDOW; _para3:longint; _para4:longint; _para5:longint;
    _para6:longint; _para7:longint; _para8:longint; _para9:longint
  ):longint;cdecl; external LIB_NCURSES;
  function curs_set(_para1:longint):longint; cdecl; external LIB_NCURSES;
  function def_prog_mode:longint; cdecl; external LIB_NCURSES;
  function def_shell_mode:longint; cdecl; external LIB_NCURSES;
  function delay_output(_para1:longint):longint; cdecl; external LIB_NCURSES;
  procedure delscreen(_para1:pSCREEN);cdecl; external LIB_NCURSES;
  function delwin(_para1:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function derwin(_para1:pWINDOW; _para2,_para3,_para4,_para5: longint): pWINDOW; cdecl; external LIB_NCURSES;
  function doupdate:longint; cdecl; external LIB_NCURSES;
  function dupwin(_para1:pWINDOW): pWINDOW; cdecl; external LIB_NCURSES;
  function echo:longint; cdecl; external LIB_NCURSES;
  function endwin:longint; cdecl; external LIB_NCURSES;
  function erasechar:char; cdecl; external LIB_NCURSES;
  procedure filter;cdecl; external LIB_NCURSES;
  function flash:longint; cdecl; external LIB_NCURSES;
  function flushinp:longint; cdecl; external LIB_NCURSES;
  function getwin(_para1:pFILE): pWINDOW; cdecl; external LIB_NCURSES;
  function halfdelay(_para1:longint):longint; cdecl; external LIB_NCURSES;
  function has_colors:bool; cdecl; external LIB_NCURSES;
  function has_ic:longint; cdecl; external LIB_NCURSES;
  function has_il:longint; cdecl; external LIB_NCURSES;
  procedure idcok(_para1:pWINDOW; _para2:bool);cdecl; external LIB_NCURSES;
  function idlok(_para1:pWINDOW; _para2:bool):longint; cdecl; external LIB_NCURSES;
  procedure immedok(_para1:pWINDOW; _para2:bool); cdecl; external LIB_NCURSES;
  function initscr: pWINDOW; cdecl; external LIB_NCURSES;
  function init_color(_para1:longint; _para2:longint; _para3:longint; _para4:longint):longint; cdecl; external LIB_NCURSES;
  function init_pair(_para1:longint; _para2:longint; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function intrflush(_para1:pWINDOW; _para2:bool):longint; cdecl; external LIB_NCURSES;
  function isendwin:longint; cdecl; external LIB_NCURSES;
  function is_linetouched(_para1:pWINDOW; _para2:longint):longint; cdecl; external LIB_NCURSES;
  function is_wintouched(_para1:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function keyname(_para1:longint):pchar; cdecl; external LIB_NCURSES;
  function keypad(_para1:pWINDOW; _para2:bool):longint; cdecl; external LIB_NCURSES;
  function killchar:char; cdecl; external LIB_NCURSES;
  function leaveok(_para1:pWINDOW; _para2:bool):longint; cdecl; external LIB_NCURSES;
  function longname: pchar; cdecl; external LIB_NCURSES;
  function meta(_para1:pWINDOW; _para2:bool):longint; cdecl; external LIB_NCURSES;
  function mvcur(_para1:longint; _para2:longint; _para3:longint; _para4:longint):longint; cdecl; external LIB_NCURSES;
  function mvderwin(_para1:pWINDOW; _para2:longint; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function mvprintw(_para1:longint; _para2:longint; _para3: pchar; _para4: va_list):longint; cdecl; external LIB_NCURSES;
  function mvscanw(_para1:longint; _para2:longint; _para3: pchar; _para4: va_list):longint; cdecl; external LIB_NCURSES;
  function mvwin(_para1:pWINDOW; _para2:longint; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function mvwprintw(win: pWINDOW; _para2,_para3:longint; _para4: pchar; _para5: va_list):longint; cdecl; external LIB_NCURSES;
  function mvwscanw(win: pWINDOW; _para2,_para3:longint; _para4: pchar; _para5: va_list):longint; cdecl; external LIB_NCURSES;
  function napms(_para1:longint):longint; cdecl; external LIB_NCURSES;
  function newpad(_para1:longint; _para2:longint): pWINDOW; cdecl; external LIB_NCURSES;
  function newterm(_para1:pchar; _para2:pFILE; _para3:pFILE): pSCREEN; cdecl; external LIB_NCURSES;
  function newwin(_para1:longint; _para2:longint; _para3:longint; _para4:longint): pWINDOW; cdecl; external LIB_NCURSES;
  function nl:longint; cdecl; external LIB_NCURSES;
  function nocbreak:longint; cdecl; external LIB_NCURSES;
  function nodelay(_para1:pWINDOW; _para2:bool):longint; cdecl; external LIB_NCURSES;
  function noecho:longint; cdecl; external LIB_NCURSES;
  function nonl:longint; cdecl; external LIB_NCURSES;
  function noqiflush:longint; cdecl; external LIB_NCURSES;
  function noraw:longint; cdecl; external LIB_NCURSES;
  function notimeout(_para1:pWINDOW; _para2:bool):longint; cdecl; external LIB_NCURSES;
  function overlay(_para1:pWINDOW; _para2:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function overwrite(_para1:pWINDOW; _para2:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function pair_content(_para1:longint; _para2:plongint; _para3:plongint):longint; cdecl; external LIB_NCURSES;
  function pechochar(_para1:pWINDOW; _para2:chtype):longint; cdecl; external LIB_NCURSES;
  function pnoutrefresh(
    _para1:pWINDOW; _para2:longint; _para3:longint; _para4:longint; _para5:longint;
    _para6:longint; _para7:longint
  ):longint;cdecl; external LIB_NCURSES;
  function prefresh(
    _para1:pWINDOW; _para2:longint; _para3:longint; _para4:longint; _para5:longint;
    _para6:longint; _para7:longint
  ):longint;cdecl; external LIB_NCURSES;
  function putp(_para1:pchar):longint; cdecl; external LIB_NCURSES;
  function putwin(_para1:pWINDOW; _para2:pFILE):longint; cdecl; external LIB_NCURSES;
  function qiflush:longint; cdecl; external LIB_NCURSES;
  function raw:longint; cdecl; external LIB_NCURSES;
  function resetty:longint; cdecl; external LIB_NCURSES;
  function reset_prog_mode:longint; cdecl; external LIB_NCURSES;
  function reset_shell_mode:longint; cdecl; external LIB_NCURSES;
  function ripoffline(_para1:longint; init: tinitfn):longint; cdecl; external LIB_NCURSES;
  function savetty:longint; cdecl; external LIB_NCURSES;
  function scanw(_para1: pchar; _para2: va_list): longInt; cdecl; external LIB_NCURSES;
  function scr_dump(_para1:pchar):longint; cdecl; external LIB_NCURSES;
  function scr_init(_para1:pchar):longint; cdecl; external LIB_NCURSES;
  function scrollok(_para1:pWINDOW; _para2:bool):longint; cdecl; external LIB_NCURSES;
  function scr_restore(_para1:pchar):longint; cdecl; external LIB_NCURSES;
  function scr_set(_para1:pchar):longint; cdecl; external LIB_NCURSES;
  function set_term(_para1:pSCREEN): pSCREEN; cdecl; external LIB_NCURSES;
  function slk_attroff(_para1:attr_t):longint; cdecl; external LIB_NCURSES;
  function slk_attron(_para1:attr_t):longint; cdecl; external LIB_NCURSES;
  function slk_attrset(_para1:attr_t):longint; cdecl; external LIB_NCURSES;
  function slk_attr:attr_t; cdecl; external LIB_NCURSES;
  function slk_attr_set(_para1:attr_t; _para2:short; _para3:pointer):longint; cdecl; external LIB_NCURSES;
  function slk_clear:longint; cdecl; external LIB_NCURSES;
  function slk_color(_para1:short):longint; cdecl; external LIB_NCURSES;
  function slk_init(_para1:longint):longint; cdecl; external LIB_NCURSES;
  function slk_label(_para1:longint):pchar; cdecl; external LIB_NCURSES;
  function slk_noutrefresh:longint; cdecl; external LIB_NCURSES;
  function slk_refresh:longint; cdecl; external LIB_NCURSES;
  function slk_restore:longint; cdecl; external LIB_NCURSES;
  function slk_set(_para1:longint; _para2:pchar; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function slk_touch:longint; cdecl; external LIB_NCURSES;
  function start_color:longint; cdecl; external LIB_NCURSES;
  function subpad (_para1:pWINDOW; _para2:longint; _para3:longint; _para4:longint; _para5:longint):PWINDOW; cdecl; external LIB_NCURSES;
  function subwin (_para1:pWINDOW; _para2:longint; _para3:longint; _para4:longint; _para5:longint):PWINDOW; cdecl; external LIB_NCURSES;
  function syncok(_para1:pWINDOW; _para2:bool):longint; cdecl; external LIB_NCURSES;
  function termattrs: chtype; cdecl; external LIB_NCURSES;
  function termname: pchar; cdecl; external LIB_NCURSES;
  function tigetflag(_para1:pchar):longint; cdecl; external LIB_NCURSES;
  function tigetnum(_para1:pchar):longint; cdecl; external LIB_NCURSES;
  function tigetstr(_para1:pchar):pchar; cdecl; external LIB_NCURSES;
  function typeahead(_para1:longint):longint; cdecl; external LIB_NCURSES;
  function ungetch(_para1:longint):longint; cdecl; external LIB_NCURSES;
  procedure use_env(_para1:bool);cdecl; external LIB_NCURSES;
  function vidattr(_para1:chtype):longint; cdecl; external LIB_NCURSES;
  function vidputs(_para1:chtype; _para2: tnc1fn):longint; cdecl; external LIB_NCURSES;
  function vwprintw(_para1:pWINDOW; _para2:pchar; _para3: va_list):longint; cdecl; external LIB_NCURSES;
  function vwscanw(_para1:pWINDOW; _para2:pchar; _para3: va_list):longint; cdecl; external LIB_NCURSES;
  function waddch(_para1:pWINDOW; _para2:chtype):longint; cdecl; external LIB_NCURSES;
  function waddchnstr(_para1:pWINDOW; _para2:pchtype; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function waddnstr(_para1:pWINDOW; _para2:pchar; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function wattr_on(_para1:pWINDOW; _para2:attr_t):longint; cdecl; external LIB_NCURSES;
  function wattr_off(_para1:pWINDOW; _para2:attr_t):longint; cdecl; external LIB_NCURSES;
  //function wattr_set(win: pwindow; at: longint): longint; cdecl; external LIB_NCURSES;
  //function wattron(win: pwindow;at: longint): longint; cdecl; external LIB_NCURSES;
  //function wattroff(win: pwindow;at: longint): longint; cdecl; external LIB_NCURSES;
  //function wattrset(win: pwindow;at: longint): longint; cdecl; external LIB_NCURSES;
  function wbkgd(_para1:pWINDOW; _para2:chtype):longint; cdecl; external LIB_NCURSES;
  procedure wbkgdset(_para1:pWINDOW; _para2:chtype);cdecl; external LIB_NCURSES;
  function wborder(
    _para1:pWINDOW; _para2:chtype; _para3:chtype; _para4:chtype; _para5:chtype;
    _para6:chtype; _para7:chtype; _para8:chtype; _para9:chtype
  ):longint;cdecl; external LIB_NCURSES;
  function wchgat(_para1:pWINDOW; _para2:longint; _para3:attr_t; _para4:longint; _para5:pointer):longint; cdecl; external LIB_NCURSES;
  function wclear(_para1:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function wclrtobot(_para1:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function wclrtoeol(_para1:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function wcolor_set(_para1:pWINDOW; _para2:short; _para3:pointer):longint; cdecl; external LIB_NCURSES;
  procedure wcursyncup(_para1:pWINDOW);cdecl; external LIB_NCURSES;
  function wdelch(_para1:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function wechochar(_para1:pWINDOW; _para2:chtype):longint; cdecl; external LIB_NCURSES;
  function werase(_para1:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function wgetch(_para1:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function wgetnstr(_para1:pWINDOW; _para2:pchar; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function whline(_para1:pWINDOW; _para2:chtype; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function winch(win: PWindow): longint; cdecl; external LIB_NCURSES;
  function winchnstr(_para1:pWINDOW; _para2:pchtype; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function winnstr(_para1:pWINDOW; _para2:pchar; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function winsch(_para1:pWINDOW; _para2:chtype):longint; cdecl; external LIB_NCURSES;
  function winsdelln(_para1:pWINDOW; _para2:longint):longint; cdecl; external LIB_NCURSES;
  function winsnstr(_para1:pWINDOW; _para2:pchar; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function wmove(_para1:pWINDOW; _para2:longint; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function wnoutrefresh(_para1:pWINDOW): longint; cdecl; external LIB_NCURSES;
  function wprintw(win: pWINDOW; _para2:pchar; _para3: va_list): longint; cdecl; external LIB_NCURSES;
  function wredrawln(_para1:pWINDOW; _para2:longint; _para3:longint):longint; cdecl; external LIB_NCURSES;
  function wrefresh(_para1:pWINDOW):longint; cdecl; external LIB_NCURSES;
  function wscanw(win: pWINDOW; _para2:pchar; _para3: va_list):longint; cdecl; external LIB_NCURSES;
  function wscrl(_para1:pWINDOW; _para2:longint):longint; cdecl; external LIB_NCURSES;
  function wsetscrreg(_para1:pWINDOW; _para2:longint; _para3:longint):longint; cdecl; external LIB_NCURSES;
  procedure wsyncdown(_para1:pWINDOW);cdecl; external LIB_NCURSES;
  procedure wsyncup(_para1:pWINDOW);cdecl; external LIB_NCURSES;
  function wtimeout(_para1:pWINDOW; _para2:longint):longint; cdecl; external LIB_NCURSES;
  function wtouchln(_para1:pWINDOW; _para2:longint; _para3:longint; _para4:longint):longint; cdecl; external LIB_NCURSES;
  function wvline(_para1:pWINDOW; _para2:chtype; _para3:longint):longint; cdecl; external LIB_NCURSES;

(* 
 * generated
 *)
  function mvwchgat(
    _para1:pWINDOW; _para2:longint; _para3:longint; _para4:longint;
    _para5:longint; _para6:longint; _para7:pointer
  ):longint;
  function PAIR_NUMBER(_para1:longint):longint;
  function color_pair(n: longint): longint;

(*
 * pseudo functions
 *)
  function wgetstr(w: pwindow; s: pchar): longint;
  function getnstr(s: pchar; n: longint): longint;

  function setterm(term: longint): longint;

  function fixterm: longint;
  function resetterm: longint;
  function saveterm: longint;
  function crmode: longint;
  function nocrmode: longint;
  // #define gettmode()

  procedure getyx(win: pwindow; var y,x: longint);
  procedure getbegyx(win: pwindow; var y,x: longint);
  procedure getmaxyx(win: pwindow; var y,x: longint);
  procedure getparyx(win: pwindow; var y,x: longint);
  Procedure getsyx(var y,x: longint);
  procedure setsyx(y,x: longint);

(* It seems older SYSV curses versions define these *)
  function getattrs(win: pwindow): longint;
  function getcurx(win: pwindow): longint;
  function getcury(win: pwindow): longint;
  function getbegx(win: pwindow): longint;
  function getbegy(win: pwindow): longint;
  function getmaxx(win: pwindow): longint;
  function getmaxy(win: pwindow): longint;
  function getparx(win: pwindow): longint;
  function getpary(win: pwindow): longint;

  function wstandout(win: pwindow): longint;
  function wstandend(win: pwindow): longint;
  function wattr_set(win: pwindow; at: longint): longint;
  function wattron(win: pwindow; at: longint): longint;
  function wattroff(win: pwindow; at: longint): longint;
  function wattrset(win: pwindow; at: longint): longint;
  function scroll(win: pwindow): longint;

  function touchwin(win: pwindow): longint;
  function touchline(win: pwindow; s,c: longint): longint;
  function untouchwin(win: pwindow): longint;

  function box(win: pwindow; v,h: longint): longint;
  function border(ls,rs,ts,bs,tl,tr,bl,br: longint): longint;
  function hline(ch,n: longint): longint;
  function vline(ch,n: longint): longint;

  function winstr(w: pwindow; s: pchar): longint;
  function winchstr(w: pwindow; s: pchar): longint;
  function winsstr(w: pwindow; s: pchar): longint;

  function redrawwin(w: pwindow): longint;
  function waddstr(win: pwindow; st: pchar): longint;
  function waddchstr(win: pwindow; st: pchar): longint;

(*
 * pseudo functions for standard screen
 *)
  function addch(ch: longint): longint;
  function addchnstr(st: pchar; n: longint): longint;
  function addchstr(st: pchar): longint;
  function addnstr(st: pchar; n: longint): longint;
  function addstr(st: pchar): longint;
  function attroff(at: longint): longint;
  function attron(at: longint): longint;
  function attrset(at: longint): longint;
  function bkgd(ch: longint): longint;
  procedure bkgdset(ch: longint);
  function clear: longint;
  function clrtobot: longint;
  function clrtoeol: longint;
  function delch: longint;
  function deleteln: longint;
  function echochar(c: longint): longint;
  function erase: longint;
  function getch: longint;
  function getstr(st: pchar): longint;
  function inch: longint;
  function inchnstr(s: pchar; n: longint): longint;
  function inchstr(s: pchar): longint;
  function innstr(s: pchar; n: longint): longint;
  function insch(c: longint): longint;
  function insdelln(n: longint): longint;
  function insertln: longint;
  function insnstr(s: pchar; n: longint): longint;
  function insstr(s: pchar): longint;
  function instr(s: pchar): longint;
  function move(y,x: longint): longint;
  function refresh: longint;
  function scrl(n: longint): longint;
  function setscrreg(t,b: longint): longint;
  function standend: longint;
  function standout: longint;
  function timeout(delay: longint): longint;
  function wdeleteln(win: pwindow): longint;
  function winsertln(win: pwindow): longint;

(*
 * mv functions
 *)

  function  mvwaddch(win: pwindow; y,x: longint; ch: chtype): longint;
  function  mvwaddchnstr(win: pwindow; y,x: longint; st: pchar; n: longint): longint;
  function  mvwaddchstr(win: pwindow; y,x: longint; st: pchar): longint;
  function  mvwaddnstr(win: pwindow; y,x: longint; st: pchar; n: longint): longint;
  function  mvwaddstr(win: pwindow; y,x: longint; st: pchar): longint;
  function  mvwdelch(win: pwindow; y,x: longint): longint;
  function  mvwgetch(win: pwindow; y,x: longint): longint;
  function  mvwgetnstr(win: pwindow; y,x: longint; st: pchar; n: longint): longint;
  function  mvwgetstr(win: pwindow; y,x: longint; st: pchar): longint;
  function  mvwhline(win: pwindow; y,x: longint; c: chtype; n: longint): longint;
  function  mvwinch(win: pwindow; y,x: longint): longint;
  function  mvwinchnstr(win: pwindow; y,x: longint; s: pchar; n: longint): longint;
  function  mvwinchstr(win: pwindow; y,x: longint; s: pchar): longint;
  function  mvwinnstr(win: pwindow; y,x: longint; s: pchar; n: longint): longint;
  function  mvwinsch(win: pwindow; y,x: longint; c: chtype): longint;
  function  mvwinsnstr(win: pwindow; y,x: longint; s: pchar; n: longint): longint;
  function  mvwinsstr(win: pwindow; y,x: longint; s: pchar): longint;
  function  mvwinstr(win: pwindow; y,x: longint; s: pchar): longint;
  function  mvwvline(win: pwindow; y,x: longint; c: chtype; n: longint): longint;

  function mvaddch(y,x,ch: longint): longint;
  function mvaddchnstr(y,x: longint; st: pchar; n: longint): longint;
  function mvaddchstr(y,x: longint; st: pchar): longint;
  function mvaddnstr(y,x: longint; st: pchar; n: longint): longint;
  function mvaddstr(y,x: longint; st: pchar): longint;
  function mvdelch(y,x: longint): longint;
  function mvgetch(y,x: longint): longint;
  function mvgetnstr(y,x: longint; st: pchar; n: longint): longint;
  function mvgetstr(y,x: longint; st: pchar): longint;
  function mvhline(y,x: longint; c: chtype; n: longint): longint;
  function mvinch(y,x: longint): longint;
  function mvinchnstr(y,x: longint; s: pchar; n: longint): longint;
  function mvinchstr(y,x: longint; s: pchar): longint;
  function mvinnstr(y,x: longint; s: pchar; n: longint): longint;
  function mvinsch(y,x: longint; c: chtype): longint;
  function mvinsnstr(y,x: longint; s: pchar; n: longint): longint;
  function mvinsstr(y,x: longint; s: pchar): longint;
  function mvinstr(y,x: longint; s: pchar): longint;
  function mvvline(y,x,c,n: longint): longint;

(*
 * XSI curses macros for XPG4 conformance.
 * The underlying functions needed to make these work are:
 * waddnwstr(), waddchnwstr(), wadd_wch(), wborder_set(), wchgat(),
 * wecho_wchar(), wgetn_wstr(), wget_wch(), whline_set(), vhline_set(),
 * winnwstr(), wins_nwstr(), wins_wch(), win_wch(), win_wchnstr().
 * Except for wchgat(), these are not yet implemented.  They will be someday.
 *)
  function attr_get: longint;
  function attr_off(a: longint): longint;
  function attr_on(a: longint): longint;
  function attr_set(a: longint): longint;
  function chgat(n,a,c,o: longint): longint;
  function getbkgd(win: pwindow): longint;
  function slk_attr_off(a: longint): longint;
  function slk_attr_on(a: longint): longint;
  function vid_attr(a: longint): longint;
  function wattr_get(win: pwindow): longint;

(*
 * Pseudo-character tokens outside ASCII range.  The curses wgetch() function
 * will return any given one of these only if the corresponding k- capability
 * is defined in your terminal's terminfo entry.
 *)
const                      {octal}
  KEY_CODE_YES = 256;      {0400}
  {$EXTERNALSYM KEY_CODE_YES}
  KEY_MIN = 257;           {0401}
  {$EXTERNALSYM KEY_MIN}
  KEY_BREAK = 257;         {0401}
  {$EXTERNALSYM KEY_BREAK}
  KEY_DOWN = 258;          {0402}
  {$EXTERNALSYM KEY_DOWN}
  KEY_UP = 259;            {0403}
  {$EXTERNALSYM KEY_UP}
  KEY_LEFT = 260;          {0404}
  {$EXTERNALSYM KEY_LEFT}
  KEY_RIGHT = 261;         {0405}
  {$EXTERNALSYM KEY_RIGHT}
  KEY_HOME = 262;          {0406}
  {$EXTERNALSYM KEY_HOME}
  KEY_BACKSPACE = 263;     {0407}
  {$EXTERNALSYM KEY_BACKSPACE}
  KEY_F0 = 264;            {0410}
  {$EXTERNALSYM KEY_F0}
  KEY_DL = 328;            {0510}
  {$EXTERNALSYM KEY_DL}
  KEY_IL = 329;            {0511}
  {$EXTERNALSYM KEY_IL}
  KEY_DC = 330;            {0512}
  {$EXTERNALSYM KEY_DC}
  KEY_IC = 331;            {0513}
  {$EXTERNALSYM KEY_IC}
  KEY_EIC = 332;           {0514}
  {$EXTERNALSYM KEY_EIC}
  KEY_CLEAR = 333;         {0515}
  {$EXTERNALSYM KEY_CLEAR}
  KEY_EOS = 334;           {0516}
  {$EXTERNALSYM KEY_EOS}
  KEY_EOL = 335;           {0517}
  {$EXTERNALSYM KEY_EOL}
  KEY_SF = 336;            {0520}
  {$EXTERNALSYM KEY_SF}
  KEY_SR = 337;            {0521}
  {$EXTERNALSYM KEY_SR}
  KEY_NPAGE = 338;         {0522}
  {$EXTERNALSYM KEY_NPAGE}
  KEY_PPAGE = 339;         {0523}
  {$EXTERNALSYM KEY_PPAGE}
  KEY_STAB = 340;          {0524}
  {$EXTERNALSYM KEY_STAB}
  KEY_CTAB = 341;          {0525}
  {$EXTERNALSYM KEY_CTAB}
  KEY_CATAB = 342;         {0526}
  {$EXTERNALSYM KEY_CATAB}
  KEY_ENTER = 343;         {0527}
  {$EXTERNALSYM KEY_ENTER}
  KEY_SRESET = 344;        {0530}
  {$EXTERNALSYM KEY_SRESET}
  KEY_RESET = 345;         {0531}
  {$EXTERNALSYM KEY_RESET}
  KEY_PRINT = 346;         {0532}
  {$EXTERNALSYM KEY_PRINT}
  KEY_LL = 347;            {0533}
  {$EXTERNALSYM KEY_LL}
  KEY_A1 = 348;            {0534}
  {$EXTERNALSYM KEY_A1}
  KEY_A3 = 349;            {0535}
  {$EXTERNALSYM KEY_A3}
  KEY_B2 = 350;            {0536}
  {$EXTERNALSYM KEY_B2}
  KEY_C1 = 351;            {0537}
  {$EXTERNALSYM KEY_C1}
  KEY_C3 = 352;            {0540}
  {$EXTERNALSYM KEY_C3}
  KEY_BTAB = 353;          {0541}
  {$EXTERNALSYM KEY_BTAB}
  KEY_BEG = 354;           {0542}
  {$EXTERNALSYM KEY_BEG}
  KEY_CANCEL = 355;        {0543}
  {$EXTERNALSYM KEY_CANCEL}
  KEY_CLOSE = 356;         {0544}
  {$EXTERNALSYM KEY_CLOSE}
  KEY_COMMAND = 357;       {0545}
  {$EXTERNALSYM KEY_COMMAND}
  KEY_COPY = 358;          {0546}
  {$EXTERNALSYM KEY_COPY}
  KEY_CREATE = 359;        {0547}
  {$EXTERNALSYM KEY_CREATE}
  KEY_END = 360;           {0550}
  {$EXTERNALSYM KEY_END}
  KEY_EXIT = 361;          {0551}
  {$EXTERNALSYM KEY_EXIT}
  KEY_FIND = 362;          {0552}
  {$EXTERNALSYM KEY_FIND}
  KEY_HELP = 363;          {0553}
  {$EXTERNALSYM KEY_HELP}
  KEY_MARK = 364;          {0554}
  {$EXTERNALSYM KEY_MARK}
  KEY_MESSAGE = 365;       {0555}
  {$EXTERNALSYM KEY_MESSAGE}
  KEY_MOVE = 366;          {0556}
  {$EXTERNALSYM KEY_MOVE}
  KEY_NEXT = 367;          {0557}
  {$EXTERNALSYM KEY_NEXT}
  KEY_OPEN = 368;          {0560}
  {$EXTERNALSYM KEY_OPEN}
  KEY_OPTIONS = 369;       {0561}
  {$EXTERNALSYM KEY_OPTIONS}
  KEY_PREVIOUS = 370;      {0562}
  {$EXTERNALSYM KEY_PREVIOUS}
  KEY_REDO = 371;          {0563}
  {$EXTERNALSYM KEY_REDO}
  KEY_REFERENCE = 372;     {0564}
  {$EXTERNALSYM KEY_REFERENCE}
  KEY_REFRESH = 373;       {0565}
  {$EXTERNALSYM KEY_REFRESH}
  KEY_REPLACE = 374;       {0566}
  {$EXTERNALSYM KEY_REPLACE}
  KEY_RESTART = 375;       {0567}
  {$EXTERNALSYM KEY_RESTART}
  KEY_RESUME = 376;        {0570}
  {$EXTERNALSYM KEY_RESUME}
  KEY_SAVE = 377;          {0571}
  {$EXTERNALSYM KEY_SAVE}
  KEY_SBEG = 378;          {0572}
  {$EXTERNALSYM KEY_SBEG}
  KEY_SCANCEL = 379;       {0573}
  {$EXTERNALSYM KEY_SCANCEL}
  KEY_SCOMMAND = 380;      {0574}
  {$EXTERNALSYM KEY_SCOMMAND}
  KEY_SCOPY = 381;         {0575}
  {$EXTERNALSYM KEY_SCOPY}
  KEY_SCREATE = 382;       {0576}
  {$EXTERNALSYM KEY_SCREATE}
  KEY_SDC = 383;           {0577}
  {$EXTERNALSYM KEY_SDC}
  KEY_SDL = 384;           {0600}
  {$EXTERNALSYM KEY_SDL}
  KEY_SELECT = 385;        {0601}
  {$EXTERNALSYM KEY_SELECT}
  KEY_SEND = 386;          {0602}
  {$EXTERNALSYM KEY_SEND}
  KEY_SEOL = 387;          {0603}
  {$EXTERNALSYM KEY_SEOL}
  KEY_SEXIT = 388;         {0604}
  {$EXTERNALSYM KEY_SEXIT}
  KEY_SFIND = 389;         {0605}
  {$EXTERNALSYM KEY_SFIND}
  KEY_SHELP = 390;         {0606}
  {$EXTERNALSYM KEY_SHELP}
  KEY_SHOME = 391;         {0607}
  {$EXTERNALSYM KEY_SHOME}
  KEY_SIC = 392;           {0610}
  {$EXTERNALSYM KEY_SIC}
  KEY_SLEFT = 393;         {0611}
  {$EXTERNALSYM KEY_SLEFT}
  KEY_SMESSAGE = 394;      {0612}
  {$EXTERNALSYM KEY_SMESSAGE}
  KEY_SMOVE = 395;         {0613}
  {$EXTERNALSYM KEY_SMOVE}
  KEY_SNEXT = 396;         {0614}
  {$EXTERNALSYM KEY_SNEXT}
  KEY_SOPTIONS = 397;      {0615}
  {$EXTERNALSYM KEY_SOPTIONS}
  KEY_SPREVIOUS = 398;     {0616}
  {$EXTERNALSYM KEY_SPREVIOUS}
  KEY_SPRINT = 399;        {0617}
  {$EXTERNALSYM KEY_SPRINT}
  KEY_SREDO = 400;         {0620}
  {$EXTERNALSYM KEY_SREDO}
  KEY_SREPLACE = 401;      {0621}
  {$EXTERNALSYM KEY_SREPLACE}
  KEY_SRIGHT = 402;        {0622}
  {$EXTERNALSYM KEY_SRIGHT}
  KEY_SRSUME = 403;        {0623}
  {$EXTERNALSYM KEY_SRSUME}
  KEY_SSAVE = 404;         {0624}
  {$EXTERNALSYM KEY_SSAVE}
  KEY_SSUSPEND = 405;      {0625}
  {$EXTERNALSYM KEY_SSUSPEND}
  KEY_SUNDO = 406;         {0626}
  {$EXTERNALSYM KEY_SUNDO}
  KEY_SUSPEND = 407;       {0627}
  {$EXTERNALSYM KEY_SUSPEND}
  KEY_UNDO = 408;          {0630}
  {$EXTERNALSYM KEY_UNDO}
  KEY_MOUSE = 409;         {0631}
  {$EXTERNALSYM KEY_MOUSE}
  KEY_RESIZE = 410;        {0632}
  {$EXTERNALSYM KEY_RESIZE}
  KEY_MAX = 511;           {0777}
  {$EXTERNALSYM KEY_MAX}

  function KEY_F(n: longint): longint;

(* mouse interface *)
const
  NCURSES_MOUSE_VERSION = 1;
  {$EXTERNALSYM NCURSES_MOUSE_VERSION}

(* event masks *)                                  // octal
  BUTTON1_RELEASED       = longWord(000000000001); // 000000000001
  {$EXTERNALSYM BUTTON1_RELEASED}
  BUTTON1_PRESSED        = longWord(000000000002); // 000000000002
  {$EXTERNALSYM BUTTON1_PRESSED}
  BUTTON1_CLICKED        = longWord(000000000004); // 000000000004
  {$EXTERNALSYM BUTTON1_CLICKED}
  BUTTON1_DOUBLE_CLICKED = longWord(000000000008); // 000000000010
  {$EXTERNALSYM BUTTON1_DOUBLE_CLICKED}
  BUTTON1_TRIPLE_CLICKED = longWord(000000000016); // 000000000020
  {$EXTERNALSYM BUTTON1_TRIPLE_CLICKED}
  BUTTON1_RESERVED_EVENT = longWord(000000000032); // 000000000040
  {$EXTERNALSYM BUTTON1_RESERVED_EVENT}
  BUTTON2_RELEASED       = longWord(000000000064); // 000000000100
  {$EXTERNALSYM BUTTON2_RELEASED}
  BUTTON2_PRESSED        = longWord(000000000128); // 000000000200
  {$EXTERNALSYM BUTTON2_PRESSED}
  BUTTON2_CLICKED        = longWord(000000000256); // 000000000400
  {$EXTERNALSYM BUTTON2_CLICKED}
  BUTTON2_DOUBLE_CLICKED = longWord(000000000512); // 000000001000
  {$EXTERNALSYM BUTTON2_DOUBLE_CLICKED}
  BUTTON2_TRIPLE_CLICKED = longWord(000000001024); // 000000002000
  {$EXTERNALSYM BUTTON2_TRIPLE_CLICKED}
  BUTTON2_RESERVED_EVENT = longWord(000000002048); // 000000004000
  {$EXTERNALSYM BUTTON2_RESERVED_EVENT}
  BUTTON3_RELEASED       = longWord(000000004096); // 000000010000
  {$EXTERNALSYM BUTTON3_RELEASED}
  BUTTON3_PRESSED        = longWord(000000008192); // 000000020000
  {$EXTERNALSYM BUTTON3_PRESSED}
  BUTTON3_CLICKED        = longWord(000000016384); // 000000040000
  {$EXTERNALSYM BUTTON3_CLICKED}
  BUTTON3_DOUBLE_CLICKED = longWord(000000032768); // 000000100000
  {$EXTERNALSYM BUTTON3_DOUBLE_CLICKED}
  BUTTON3_TRIPLE_CLICKED = longWord(000000065536); // 000000200000
  {$EXTERNALSYM BUTTON3_TRIPLE_CLICKED}
  BUTTON3_RESERVED_EVENT = longWord(000000131072); // 000000400000
  {$EXTERNALSYM BUTTON3_RESERVED_EVENT}
  BUTTON4_RELEASED       = longWord(000000262144); // 000001000000
  {$EXTERNALSYM BUTTON4_RELEASED}
  BUTTON4_PRESSED        = longWord(000000524288); // 000002000000
  {$EXTERNALSYM BUTTON4_PRESSED}
  BUTTON4_CLICKED        = longWord(000001048576); // 000004000000
  {$EXTERNALSYM BUTTON4_CLICKED}
  BUTTON4_DOUBLE_CLICKED = longWord(000002097152); // 000010000000
  {$EXTERNALSYM BUTTON4_DOUBLE_CLICKED}
  BUTTON4_TRIPLE_CLICKED = longWord(000004194304); // 000020000000
  {$EXTERNALSYM BUTTON4_TRIPLE_CLICKED}
  BUTTON4_RESERVED_EVENT = longWord(000008388608); // 000040000000
  {$EXTERNALSYM BUTTON4_RESERVED_EVENT}
  BUTTON_CTRL            = longWord(000016777216); // 000100000000
  {$EXTERNALSYM BUTTON_CTRL}
  BUTTON_SHIFT           = longWord(000033554432); // 000200000000
  {$EXTERNALSYM BUTTON_SHIFT}
  BUTTON_ALT             = longWord(000067108864); // 000400000000
  {$EXTERNALSYM BUTTON_ALT}
  ALL_MOUSE_EVENTS       = longWord(000134217727); // 000777777777
  {$EXTERNALSYM ALL_MOUSE_EVENTS}
  REPORT_MOUSE_POSITION  = longWord(000134217728); // 001000000000
  {$EXTERNALSYM REPORT_MOUSE_POSITION}


type
  mmask_t = longWord;
  pmevent = ^mevent;
  mevent = record
    id    : short;
    x     : longint;
    y     : longint;
    z     : longint;
    bstate: mmask_t;
  end;

  function getmouse(pme: pmevent): longInt; cdecl; external LIB_NCURSES;
  function ungetmouse(pme: pmevent): longInt; cdecl; external LIB_NCURSES;
  function mousemask(mm1: mmask_t; var mm2: mmask_t): mmask_t; cdecl; external LIB_NCURSES;
  function wenclose(const win: pWINDOW; _param1,_param2: longint): bool; cdecl; external LIB_NCURSES;
  function mouseinterval(_param1: longint): longInt; cdecl; external LIB_NCURSES;
  function wmouse_trafo(const win: pWINDOW; var y, x: longint; to_screen: bool): bool; cdecl; external LIB_NCURSES;

  function mouse_trafo(var y, x: longInt; to_screen: bool): bool;

(* macros to extract single event-bits from masks *)
  function BUTTON_RELEASE(e,x: mmask_t): mmask_t;           // ((e) & (001 << (6 * ((x) - 1))))
  function BUTTON_PRESS(e,x: mmask_t): mmask_t;             // ((e) & (002 << (6 * ((x) - 1))))
  function BUTTON_CLICK(e,x: mmask_t): mmask_t;             // ((e) & (004 << (6 * ((x) - 1))))
  function BUTTON_DOUBLE_CLICK(e,x: mmask_t): mmask_t;      // ((e) & (010 << (6 * ((x) - 1))))
  function BUTTON_TRIPLE_CLICK(e,x: mmask_t): mmask_t;      // ((e) & (020 << (6 * ((x) - 1))))
  function BUTTON_RESERVED_EVENT(e,x: mmask_t): mmask_t;    // ((e) & (040 << (6 * ((x) - 1))))

(* other non-XSI functions *)
  function mcprint(_para1:pchar; _para2:longint):longint; cdecl; external LIB_NCURSES;
  function has_key(_para1:longint):longint; cdecl; external LIB_NCURSES;

implementation

function ACS_ULCORNER: chtype;
begin
  Result:= acs_map['l'];
end;

function ACS_LLCORNER: chtype;
begin
  Result:= acs_map['m'];
end;

function ACS_URCORNER: chtype;
begin
  Result:= acs_map['k'];
end;

function ACS_LRCORNER: chtype;
begin
  Result:= acs_map['j'];
end;

function ACS_LTEE: chtype;
begin
  Result:= acs_map['t'];
end;

function ACS_RTEE: chtype;
begin
  Result:= acs_map['u'];
end;

function ACS_BTEE: chtype;
begin
  Result:= acs_map['v'];
end;

function ACS_TTEE: chtype;
begin
  Result:= acs_map['w'];
end;

function ACS_HLINE: chtype;
begin
  Result:= acs_map['q'];
end;

function ACS_VLINE: chtype;
begin
  Result:= acs_map['x'];
end;

function ACS_PLUS: chtype;
begin
  Result:= acs_map['n'];
end;

function ACS_S1: chtype;
begin
  Result:= acs_map['o'];
end;

function ACS_S9: chtype;
begin
  Result:= acs_map['s'];
end;

function ACS_DIAMOND: chtype;
begin
  Result:= acs_map['`'];
end;

function ACS_CKBOARD: chtype;
begin
  Result:= acs_map['a'];
end;

function ACS_DEGREE: chtype;
begin
  Result:= acs_map['f'];
end;

function ACS_PLMINUS: chtype;
begin
  Result:= acs_map['g'];
end;

function ACS_BULLET: chtype;
begin
  Result:= acs_map['~'];
end;

function ACS_LARROW: chtype;
begin
  Result:= acs_map[','];
end;

function ACS_RARROW: chtype;
begin
  Result:= acs_map['+'];
end;

function ACS_DARROW: chtype;
begin
  Result:= acs_map['.'];
end;

function ACS_UARROW: chtype;
begin
  Result:= acs_map['-'];
end;

function ACS_BOARD: chtype;
begin
  Result:= acs_map['h'];
end;

function ACS_LANTERN: chtype;
begin
  Result:= acs_map['i'];
end;

function ACS_BLOCK: chtype;
begin
  Result:= acs_map['0'];
end;

function ACS_S3: chtype;
begin
  Result:= acs_map['p'];
end;

function ACS_S7: chtype;
begin
  Result:= acs_map['r'];
end;

function ACS_LEQUAL: chtype;
begin
  Result:= acs_map['y'];
end;

function ACS_GEQUAL: chtype;
begin
  Result:= acs_map['z'];
end;

function ACS_PI: chtype;
begin
  Result:= acs_map['{'];
end;

function ACS_NEQUAL: chtype;
begin
  Result:= acs_map['|'];
end;

function ACS_STERLING: chtype;
begin
  Result:= acs_map['}'];
end;

function ACS_BSSB: chtype;
begin
  Result:= ACS_ULCORNER;
end;

function ACS_SSBB: chtype;
begin
  Result:= ACS_LLCORNER;
end;

function ACS_BBSS: chtype;
begin
  Result:= ACS_URCORNER;
end;

function ACS_SBBS: chtype;
begin
  Result:= ACS_LRCORNER;
end;

function ACS_SBSS: chtype;
begin
  Result:= ACS_RTEE;
end;

function ACS_SSSB: chtype;
begin
  Result:= ACS_LTEE;
end;

function ACS_SSBS: chtype;
begin
  Result:= ACS_BTEE;
end;

function ACS_BSSS: chtype;
begin
  Result:= ACS_TTEE;
end;

function ACS_BSBS: chtype;
begin
  Result:= ACS_HLINE;
end;

function ACS_SBSB: chtype;
begin
  Result:= ACS_VLINE;
end;

function ACS_SSSS: chtype;
begin
  Result:= ACS_PLUS;
end;

function wgetstr(w: pwindow; s: pchar): longint;
begin
  Result:= wgetnstr(w, s, -(1));
end;

function getnstr(s: pchar; n: longint): longint;
begin
  Result:= wgetnstr(stdscr, s, n);
end;

function setterm(term: longint): longint;
begin
  Result:= 0; {setupterm(term, 1, plongint(0));}
end;

function fixterm: longint;
begin
  Result:= reset_prog_mode;
end;

function resetterm: longint;
begin
  Result:= reset_shell_mode;
end;

function saveterm: longint;
begin
  Result:= def_prog_mode;
end;

function crmode: longint;
begin
  Result:= cbreak;
end;

function nocrmode: longint;
begin
  Result:= nocbreak;
end;

procedure getsyx(var y,x: longint);
begin
  getyx(stdscr,y,x);
end;

function getattrs(win: pwindow): longint;
begin
  if Assigned(win) then
    Result:= win^._attrs
  else
    Result:= A_NORMAL;
end;

function getcurx(win: pwindow): longint;
begin
  if Assigned(win) then
    Result:= win^._curx
  else
    Result:= ERR;
end;

function getcury(win: pwindow): longint;
begin
  if Assigned(win) then
    Result:= win^._cury
  else
    Result:= ERR;
end;

function getbegx(win: pwindow): longint;
begin
  if Assigned(win) then
    Result:= win^._begx
  else
    Result:= ERR;
end;

function getbegy(win: pwindow): longint;
begin
  if Assigned(win) then
    Result:= win^._begy
  else
    Result:= ERR;
end;

function getmaxx(win: pwindow): longint;
begin
  if Assigned(win) then
    Result:= (win^._maxx) + 1
  else
    Result:= ERR;
end;

function getmaxy(win: pwindow): longint;
begin
  if Assigned(win) then
    Result:= (win^._maxy) + 1
  else
    Result:= ERR;
end;

function getparx(win: pwindow): longint;
begin
  if Assigned(win) then
    Result:= win^._parx
  else
    Result:= ERR;
end;

function getpary(win: pwindow): longint;
begin
  if Assigned(win) then
    Result:= win^._pary
  else
    Result:= ERR;
end;

function wstandout(win: pwindow): longint;
begin
  Result:= wattr_set(win, A_STANDOUT);
end;

function wstandend(win: pwindow): longint;
begin
  Result:= wattr_set(win, A_NORMAL);
end;


function wattron(win: pwindow; at: longint): longint;
begin
  Result:= wattr_on(win, at);
end;

function wattroff(win: pwindow; at: longint): longint;
begin
  Result:= wattr_off(win, at);
end;

function wattrset(win: pwindow; at: longint): longint;
begin
  Result:= wattr_set(win, at);
end;

function scroll(win: pwindow): longint;
begin
  Result:= wscrl(win, 1);
end;

function touchwin(win: pwindow): longint;
begin
  Result:= wtouchln(win, 0, getmaxy(win), 1);
end;

function touchline(win: pwindow; s, c: longint): longint;
begin
  Result:= wtouchln(win, s, c, 1);
end;

function untouchwin(win: pwindow): longint;
begin
  Result:= wtouchln(win, 0, getmaxy(win), 0);
end;

function box(win: pwindow; v, h: longint): longint;
begin
  Result:= wborder(win, v, v, h, h, 0, 0, 0, 0);
end;

function border(ls, rs, ts, bs, tl, tr, bl, br: longint): longint;
begin
  Result:= wborder(stdscr, ls, rs, ts, bs, tl, tr, bl, br);
end;

function hline(ch, n: longint): longint;
begin
  Result:= whline(stdscr, ch, n);
end;

function vline(ch, n: longint): longint;
begin
  Result:= wvline(stdscr, ch, n);
end;

function winstr(w: pwindow; s: pchar): longint;
begin
  Result:= winnstr(w, s, -(1));
end;

function winchstr(w: pwindow; s: pchar): longint;
begin
  Result:= winchnstr(w, s, -1);
end;

function winsstr(w: pwindow; s: pchar): longint;
begin
  Result:= winsnstr(w, s, -(1));
end;

function redrawwin(w: pwindow): longint;
begin
  Result:= wredrawln(w, 0, (w^._maxy)+1);
end;

function waddstr(win: pwindow; st: pchar): longint;
begin
  Result:= waddnstr(win, st, -1);
end;

function waddchstr(win: pwindow; st: pchar): longint;
begin
  Result:= waddchnstr(win, st, -1);
end;

function addch(ch: longint): longint;
begin
  Result:= waddch(stdscr, ch);
end;

function addchnstr(st: pchar; n: longint): longint;
begin
  Result:= waddchnstr(stdscr, st, n);
end;

function addchstr(st: pchar): longint;
begin
  Result:= waddchstr(stdscr, st);
end;

function addnstr(st: pchar; n: longint): longint;
begin
  Result:= waddnstr(stdscr, st, n);
end;

function addstr(st: pchar): longint;
begin
  Result:= waddnstr(stdscr, st, -1);
end;

function attroff(at: longint): longint;
begin
  Result:= wattroff(stdscr, at);
end;

function attron(at: longint): longint;
begin
  Result:= wattron(stdscr, at);
end;

function attrset(at: longint): longint;
begin
  Result:=wattrset(stdscr, at);
end;

function bkgd(ch: longint): longint;
begin
  Result:= wbkgd(stdscr, ch);
end;

procedure bkgdset(ch: longint);
begin
  wbkgdset(stdscr, ch);
end;

function clear: longint;
begin
  Result:= wclear(stdscr);
end;

function clrtobot: longint;
begin
  Result:= wclrtobot(stdscr);
end;

function clrtoeol: longint;
begin
  Result:= wclrtoeol(stdscr);
end;

function delch: longint;
begin
  Result:= wdelch(stdscr);
end;

function deleteln: longint;
begin
  Result:= winsdelln(stdscr, -1);
end;

function echochar(c: longint): longint;
begin
  Result:= wechochar(stdscr, c);
end;

function erase: longint;
begin
  Result:= werase(stdscr);
end;

function getch: longint;
begin
  Result:= wgetch(stdscr);
end;

function getstr(st: pchar): longint;
begin
  Result:= wgetstr(stdscr,st);
end;

function inch: longint;
begin
  Result:= winch(stdscr);
end;

function inchnstr(s: pchar; n: longint): longint;
begin
  Result:= winchnstr(stdscr, s, n);
end;

function inchstr(s: pchar): longint;
begin
  Result:= winchstr(stdscr, s);
end;

function innstr(s: pchar; n: longint): longint;
begin
  Result:= winnstr(stdscr, s, n);
end;

function insch(c: longint): longint;
begin
  Result:= winsch(stdscr, c);
end;

function insdelln(n: longint): longint;
begin
  Result:= winsdelln(stdscr, n);
end;

function insertln: longint;
begin
  Result:= winsdelln(stdscr, 1);
end;

function insnstr(s: pchar; n: longint): longint;
begin
  Result:= winsnstr(stdscr, s, n);
end;

function insstr(s: pchar): longint;
begin
  Result:= winsstr(stdscr, s);
end;

function instr(s: pchar): longint;
begin
  Result:= winstr(stdscr, s);
end;

function move(y, x: longint): longint;
begin
  Result:= wmove(stdscr, y, x);
end;

function refresh: longint;
begin
  Result:= wrefresh(stdscr);
end;

function scrl(n: longint): longint;
begin
  Result:= wscrl(stdscr, n);
end;

function setscrreg(t,b: longint): longint;
begin
  Result:= wsetscrreg(stdscr, t, b);
end;

function standend: longint;
begin
  Result:= wstandend(stdscr);
end;

function standout: longint;
begin
  Result:= wstandout(stdscr);
end;

function timeout(delay: longint): longint;
begin
  Result:= wtimeout(stdscr, delay);
end;

function wdeleteln(win: pwindow): longint;
begin
  Result:= winsdelln(win, -1);
end;

function winsertln(win: pwindow): longint;
begin
  Result:= winsdelln(win, 1);
end;

function mvaddch(y,x,ch: longint): longint;
begin
  Result:= mvwaddch(stdscr, y, x, ch);
end;

function mvaddchnstr(y,x: longint; st: pchar; n: longint): longint;
begin
  Result:= mvwaddchnstr(stdscr, y, x, st, n);
end;

function mvaddchstr(y,x: longint; st: pchar): longint;
begin
  Result:= mvwaddchstr(stdscr, y, x, st);
end;

function mvaddnstr(y,x: longint; st: pchar; n: longint): longint;
begin
  Result:= mvwaddnstr(stdscr, y, x, st, n);
end;

function mvaddstr(y,x: longint; st: pchar): longint;
begin
  Result:= mvwaddstr(stdscr, y, x, st);
end;

function mvdelch(y,x: longint): longint;
begin
  Result:= mvwdelch(stdscr, y, x);
end;

function mvgetch(y,x: longint): longint;
begin
  Result:= mvwgetch(stdscr, y, x);
end;

function mvgetnstr(y,x: longint; st: pchar; n: longint): longint;
begin
  Result:= mvwgetnstr(stdscr, y, x, st, n);
end;

function mvgetstr(y,x: longint; st: pchar): longint;
begin
  Result:= mvwgetstr(stdscr, y, x, st);
end;

function mvhline(y,x: longint; c: chtype; n: longint): longint;
begin
  Result:= mvwhline(stdscr, y, x, c, n);
end;

function mvinch(y,x: longint): longint;
begin
  Result:= mvwinch(stdscr, y, x);
end;

function mvinchnstr(y,x: longint; s: pchar; n: longint): longint;
begin
  Result:= mvwinchnstr(stdscr, y, x, s, n);
end;

function mvinchstr(y,x: longint; s: pchar): longint;
begin
  Result:= mvwinchstr(stdscr, y, x, s);
end;

function mvinnstr(y,x: longint; s: pchar; n: longint): longint;
begin
  Result:= mvwinnstr(stdscr, y, x, s, n);
end;

function mvinsch(y,x: longint; c: chtype): longint;
begin
  Result:= mvwinsch(stdscr, y, x, c);
end;

function mvinsnstr(y,x: longint; s: pchar; n: longint): longint;
begin
  Result:= mvwinsnstr(stdscr, y, x, s, n);
end;

function mvinsstr(y,x: longint; s: pchar): longint;
begin
  Result:= mvwinsstr(stdscr, y, x, s);
end;

function mvinstr(y,x: longint; s: pchar): longint;
begin
  Result:= mvwinstr(stdscr, y, x, s);
end;

function mvvline(y,x,c,n: longint): longint;
begin
  Result:= mvwvline(stdscr, y, x, c, n);
end;

function attr_get: longint;
begin
  Result:= wattr_get(stdscr);
end;

function attr_off(a: longint): longint;
begin
  Result:= wattr_off(stdscr, a);
end;

function attr_on(a: longint): longint;
begin
  Result:= wattr_on(stdscr, a);
end;

function attr_set(a: longint): longint;
begin
  Result:= wattr_set(stdscr, a);
end;

function chgat(n,a,c,o: longint): longint;
begin
  Result:= wchgat(stdscr, n, a, c, pointer(o));
end;

function getbkgd(win: pwindow): longint;
begin
  Result:= win^._bkgd;
end;

function mvchgat(y,x,n,a,c,o: longint): longint;
begin
  Result:= mvwchgat(stdscr, y, x, n, a, c, pointer(o));
end;

function slk_attr_off(a: longint): longint;
begin
  Result:= slk_attroff(a);
end;

function slk_attr_on(a: longint): longint;
begin
  Result:= slk_attron(a);
end;

function vid_attr(a: longint): longint;
begin
  Result:= vidattr(a);
end;

function wattr_get(win: pwindow): longint;
begin
  Result:= win^._attrs;
end;

function KEY_F(n: longint): longint;
begin
  Result:= KEY_F0+n;
end;

procedure getyx(win: pwindow; var y,x: longint);
begin
  X:=ERR;
  Y:=ERR;
  if Assigned(win) then begin
    Y:= win^._cury;
    X:= win^._curx;
  end;
end;

procedure getbegyx(win: pwindow; var y,x: longint);
begin
  X:=ERR;
  Y:=ERR;
  if Assigned(win) then begin
     Y:= win^._begy;
     X:= win^._begx;
  end;
end;

procedure getmaxyx(win: pwindow; var y,x: longint);
begin
  X:=ERR;
  Y:=ERR;
  if Assigned(win) then begin
    Y:= win^._maxy+1;
    X:= win^._maxx+1;
  end;
end;

procedure getparyx(win: pwindow; var y,x: longint);
begin
  X:=ERR;
  Y:=ERR;
  if Assigned(win) then begin
    Y:= win^._pary;
    X:= win^._parx;
  end;
end;

(*
function winch(win: PWindow): longint;
begin
  if Assigned(win) then
    Result:= win^._line[win^._cury].text[win^ ._curx]
  else
    Result:= 0;
end;
*)

function wattr_set(win: pwindow; at: longint): longint;
begin
  if Assigned(win) then begin
    win^._attrs:= at;
    Result:= at;
  end else begin
    Result:= 0;
  end;
end;

procedure setsyx (y,x: longint);
begin
  stdscr^._cury:= y;
  stdscr^._curx:= x;
end;

function mvwaddch(win: pwindow; y,x: longint; ch: chtype): longint;
begin
  if wmove(win,y,x) = ERR then
    Result:= ERR
  else
    Result:= waddch(win,ch)
end;

function mvwaddchnstr(win: pwindow; y,x: longint; st: pchar; n: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= waddchnstr(win,st,n)
end;

function mvwaddchstr(win: pwindow; y,x: longint; st: pchar): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= waddchnstr(win,st,-1)
end;

function mvwaddnstr(win: pwindow; y,x: longint; st: pchar; n: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= waddnstr(win,st,n)
end;

function mvwaddstr(win: pwindow; y,x: longint; st: pchar): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= waddnstr(win,st,-1)
end;

function mvwdelch(win: pwindow; y,x: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= wdelch(win)
end;

function mvwgetch(win: pwindow; y,x: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= wgetch(win)
end;

function mvwgetnstr(win: pwindow; y,x: longint; st: pchar; n: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= wgetnstr(win,st,n)
end;

function mvwgetstr(win: pwindow; y,x: longint; st: pchar): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= wgetstr(win,st)
end;

function mvwhline(win: pwindow; y,x: longint; c: chtype; n: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= whline(win,c,n)
end;

function mvwinch(win: pwindow; y,x: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= winch(win)
end;

function mvwinchnstr(win: pwindow; y,x: longint; s: pchar; n: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= winchnstr(win,s,n)
end;

function mvwinchstr(win: pwindow; y,x: longint; s: pchar): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= winchstr(win,s)
end;

function mvwinnstr(win: pwindow; y,x: longint; s: pchar; n: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= winnstr(win,s,n)
end;

function mvwinsch(win: pwindow; y,x: longint; c: chtype): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= winsch(win,c)
end;

function mvwinsnstr(win: pwindow; y,x: longint; s: pchar; n: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= winsnstr(win,s,n)
end;

function mvwinsstr(win: pwindow; y,x: longint; s: pchar): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= winsstr(win,s)
end;

function mvwinstr(win: pwindow; y,x: longint; s: pchar): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= winstr(win,s)
end;

function mvwvline(win: pwindow; y,x: longint; c: chtype; n: longint): longint;
begin
  if wmove (win,y,x)=ERR then
    Result:= ERR
  else
    Result:= wvline(win,c,n)
end;

function mvwchgat(
  _para1:pWINDOW; _para2:longint; _para3:longint; _para4:longint;
  _para5:longint; _para6:longint; _para7:pointer
):longint;
begin
  Result:= wmove(_para1, _para2, _para3);
  If Result <> ERR then
    Result:= wchgat(_para1, _para4, _para5, _para6, _para7);
end;

function PAIR_NUMBER(_para1:longint):longint;
begin
  Result:= (((_para1) and A_COLOR) shr 8)
end;

function color_pair(n: longint): longint;
begin
  Result:= n shl 8;
end;

function mouse_trafo(var y, x: longInt; to_screen: bool): bool;
begin
  Result:= wmouse_trafo(stdscr, y, x, to_screen);
end;

function BUTTON_RELEASE(e,x: mmask_t): mmask_t;
begin
  Result:= ((e) and (001 shl (6 * ((x) - 1))))
end;

function BUTTON_PRESS(e,x: mmask_t): mmask_t;
begin
  Result:= ((e) and (002 shl (6 * ((x) - 1))))
end;

function BUTTON_CLICK(e,x: mmask_t): mmask_t;
begin
  Result:= ((e) and (004 shl (6 * ((x) - 1))))
end;

function BUTTON_DOUBLE_CLICK(e,x: mmask_t): mmask_t;
begin
  Result:= ((e) and (010 shl (6 * ((x) - 1))))
end;

function BUTTON_TRIPLE_CLICK(e,x: mmask_t): mmask_t;
begin
  Result:= ((e) and (020 shl (6 * ((x) - 1))))
end;

function BUTTON_RESERVED_EVENT(e,x: mmask_t): mmask_t;
begin
  Result:= ((e) and (040 shl (6 * ((x) - 1))))
end;

end.



